﻿using System;
using System.Text;

namespace ComPortSniffer
{
   public enum TextBlockColors
   {
      Port1 = 1,
      Port2 = 2
   }

   public class TextBlock
   {
      private static string[] CharNames = new string[] { "<NUL>", "<SOH>", "<STX>", "<ETX>", "<EOT>", "<ENQ>", "<ACK>", "<BEL>", "<BS>", "<TAB>", "<LF>", "<VT>", "<FF>", "<CR>", "<SO>", "<SI>", "<DLE>", "<DC1>", "<DC2>", "<DC3>", "<DC4>", "<NAK>", "<SYN>", "<ETB>", "<CAN>", "<EM>", "<SUB>", "<ESC>", "<FS>", "<GS>", "<RS>", "<US>", "<SP>" };
      private static StringBuilder sb = new StringBuilder(200);

      public byte[] text;
      public TextBlockColors color;

      public TextBlock(byte[] data, TextBlockColors color)
      {
         this.text = data;
         this.color = color;
      }

      public String getRTF(Boolean hex = false)
      {
         sb.Clear();
         sb.Append("\\cf");
         sb.Append((int)color);
         sb.Append(" ");

         foreach (byte c in text)
         {
            if (hex)
            {
               sb.Append(String.Format("{0:X2} ", (int)c));
            }
            else
            {
               if (c < 32)
               {
                  sb.Append(CharNames[c]);
                  if (c == 10)
                     sb.Append("\\par ");
               }
               else
                  sb.Append((char)c);
            }
         }
         return sb.ToString();
      } // getRTF
   } // class
} // Namespace
